
#Utility function. See PHP's explode function.
function explode ()
{ # $1==string to explode, $2==delimiter, $3==name of array to put it in
	local count i varname
	[[ $3 ]] || return 1
	let count=0
	for i in `echo "$1" | awk -F "$2" '{ for(i=1;i<=NF; i++) print $i; }'` ; do
		varname="$3[$count]"
		eval $varname=$i
		let count++
	done	
}

#Removes triggers from the list, used after a dispel
function remove_triggers ()
{ # $1==spell whos triggers must be removed
	[ -f $TRIGGER_FILE ] || return 0
	egrep -v "^[^:]*:$SPELL:" $TRIGGER_LIST > /tmp/triggers.$$.tmp
	mv /tmp/triggers.$$.tmp $TRIGGER_LIST
	return $?
}

#Trigger an event:
function trigger ()
{ # $1==event triggered, $2==(OPT)what spell is triggering this event
	local i TRIGGER	spell
	spell=${SPELL:-$4}
	TRIGGER=()
	for i in `egrep "^$spell:[^:]*:on_$1" $TRIGGER_LIST` ; do
		explode "$i" ":" TRIGGER
		query "${TRIGGER[0]} being $1 has triggered a ${TRIGGER[3]} on spell ${TRIGGER[1]}. Proceed? " "y"
		[[ $? != 0 ]] && continue
		#otherwise continue... hmmm, I've always thought that keyword was bad.
		
		#Ok, now do the required action:
		case ${TRIGGER[3]} in
			cast_self)
				cast -c "${TRIGGER[1]}"
				;;
			dispel_self)
				dispel "${TRIGGER[1]}"
				;;
			check_self)
				cast --fix "${TRIGGER[1]}"
				;;
			run_script*)
				${TRIGGER[3]}
				;;
			*)
				message "${PROBLEM_COLOR}${TRIGGER[3]} is not a known kind of trigger.${DEFAULT_COLOR}"
		esac
	done	
}

#Record a trigger in the list
function set_trigger ()
{ #1==trigger to set, $2==spell that triggers it, $3=action, $4==(optional)spell this is for
	local str spell
	[[ $4 ]] || [[ $SPELL ]] || return 1
	case $3 in
		cast_self|dispel_self|check_self|run_script)
			;;
		*)
			message "${PROBLEM_COLOR}$3 is not a valid trigger action.${DEFAULT_COLOR}"
			return 1
			;;
	esac
	case $1 in
		on_cast|on_pre_cast|on_dispel|on_pre_dispel)
			;;
		*)
			message "${PROBLEM_COLOR}$1 is not a valid trigger.${DEFAULT_COLOR}"
			return 1
			;;
	esac
	#perhaps a check to make sure that $2 exists?
	
	spell=${SPELL:-$4}
	str="$2:$spell:$1:$3"
	grep -q "$str" $TRIGGER_FILE || echo "$str" >> $TRIGGER_LIST
}

#Several functions to make TRIGGER file writing easier.
function on_cast ()
{ set_trigger "on_cast" "$1" "$2"; }
function on_dispel ()
{ set_trigger "on_dispel" "$1" "$2"; }
function on_pre_cast ()
{ set_trigger "on_pre_cast" "$1" "$2"; }
function on_pre_dispel ()
{ set_trigger "on_pre_dispel" "$1" "$2"; }

